#include "StdAfx.h"
#include "gpu_i.h"

	short maskB[4] = {0x001f,0x001f,0x001f,0x001f};
	short maskR[4] = {0x7c00,0x7c00,0x7c00,0x7c00};
	short maskG[4] = {0x03e0,0x03e0,0x03e0,0x03e0};


/*
	first digit:
 		0 = 320
	second digit:
		0 = 240
		1 = 480
*/

void blitScreenMMX00(unsigned long dst, unsigned long pitch, unsigned long width)
{
	_asm 
	{
		push	edi
		push	esi
        mov     ecx,[dispHor]
        mov     edx,[psxVuw]
        movzx   eax,[dispPosY]
		mov		ebx,eax
        shl     eax,11
		add		ebx,ecx
        add     edx,eax
		cmp		ebx,511
		jnc		_inrange
		mov		ecx,511
		sub		ecx,[dispPosY]
_inrange:
        movzx   eax,[dispPosX]
        shl     eax,1
        add     edx,eax
        movq    mm0,[maskR]
        movq    mm1,[maskB]
        movq    mm2,[maskG]
        mov     edi,width
        mov     ebx,dst
        shr     edi,3
_aline:
        mov     eax,edi
        mov     esi,0
_sline:
        movq    mm3,[edx+esi]
        movq    mm6,[edx+esi+8]
        movq    mm4,mm3
        movq    mm5,mm6
        pand    mm4,mm0
        movq    mm7,mm3
        pand    mm5,mm0
        pand    mm3,mm2
        psrlw   mm4,10
        pand    mm7,mm1
        por     mm3,mm4
        psrlw   mm5,10
        movq    mm4,mm6
        psllw   mm7,10
        pand    mm4,mm2
        pand    mm6,mm1
        por     mm3,mm7
        psllw   mm6,10
        por     mm4,mm5
        movq    [ebx],mm3
        por     mm6,mm4
        add     esi,16
        movq    [ebx+8],mm6
        add     ebx,16
        dec     eax
        jnz     _sline
        add     edx,2048
		add		ebx,pitch
        
        loop    _aline        
        emms
		pop		esi
		pop		edi
	}
}




void blitScreenMMX01(unsigned long dst, unsigned long pitch, unsigned long width)
{
	_asm 
	{
		push	edi
		push	esi
        mov     ecx,480
        mov     ebx,dst
        mov     edx,[psxVuw]
        movzx   eax,[dispPosY]
        shl     eax,11
        add     edx,eax
        movzx   eax,[dispPosX]
        shl     eax,1
        add     edx,eax
        movq    mm0,[maskR]
        movq    mm1,[maskB]
        movq    mm2,[maskG]
        mov     edi,width
        shr     edi,3
_aline:
        mov     eax,edi
        mov     esi,0
_sline:
        movq    mm3,[edx+esi]
        movq    mm6,[edx+esi+8]
        movq    mm4,mm3
        movq    mm5,mm6
        pand    mm4,mm0
        movq    mm7,mm3
        pand    mm5,mm0
        pand    mm3,mm2
        psrlw   mm4,10
        pand    mm7,mm1
        por     mm3,mm4
        psrlw   mm5,10
        movq    mm4,mm6
        psllw   mm7,10
        pand    mm4,mm2
        pand    mm6,mm1
        por     mm3,mm7
        psllw   mm6,10
        por     mm4,mm5
        movq    [ebx],mm3
        por     mm6,mm4
        add     esi,16
        movq    [ebx+8],mm6
        add     ebx,16
        dec     eax
        jnz     _sline
        add     edx,2048
		add		ebx,pitch
        
        loop    _aline        
        emms
		pop		esi
		pop		edi
	}
}

void blitScreen24_00(unsigned long dst, unsigned long pitch, unsigned long width)
{
	_asm 
	{
		push	edi
		push	esi
        mov     ecx,[dispVer]
        mov     ebx,dst
        mov     edx,[psxVuw]
        movzx   eax,[dispPosY]
        shl     eax,11
        add     edx,eax
        movzx   eax,[dispPosX]
        shl     eax,1
        add     edx,eax
/*        movq    mm0,[maskR]
        movq    mm1,[maskB]
        movq    mm2,[maskG]
*/
        mov     edi,width
        //shr     edi,3
_aline:
		push	ecx
        mov     ecx,edi
		push	edx
_sline:
		push	ecx

		mov		ax,word ptr [edx]
		add		edx,2
		mov		ecx,eax
		mov		esi,eax
		and		eax,01fh
		and		ecx,03e0h
		and		esi,07c00h
		shr		esi,7
		shl		ecx,6
		shl		eax,19
		or		ecx,esi
		or		eax,ecx
		mov		[ebx],eax
		pop		ecx
		add		ebx,4
        loop    _sline
		pop		edx
        add     edx,2048
		add		ebx,pitch
        pop		ecx
        loop    _aline        
		pop		esi
		pop		edi
	}
}


void blitScreen24_01(unsigned long dst, unsigned long pitch, unsigned long width)
{
	return;
	_asm 
	{
		push	edi
		push	esi
        mov     ecx,480
		//sub		ecx,[dispPosY]
        mov     ebx,dst
        mov     edx,[psxVuw]
        movzx   eax,[dispPosY]
        shl     eax,11
        add     edx,eax
        movzx   eax,[dispPosX]
        shl     eax,1
        add     edx,eax
        mov     edi,width
_aline:
		push	ecx
        mov     ecx,edi
		push	edx
_sline:
		push	ecx
		mov		ax,word ptr [edx]
		add		edx,2
		mov		ecx,eax
		mov		esi,eax
		and		eax,01fh
		and		ecx,03e0h
		and		esi,07c00h
		shr		esi,7
		shl		ecx,6
		shl		eax,19
		or		eax,ecx
		or		eax,esi
		mov		[ebx],eax
		add		ebx,4
		pop		ecx
        loop    _sline
		pop		edx
        add     edx,2048
		add		ebx,pitch
        pop		ecx
        loop    _aline        
		pop		esi
		pop		edi
	}
}

void blitScreenMMX00s(unsigned long dst, unsigned long pitch, unsigned long width)
{
	unsigned long myWidth, myHeight;
	myHeight = dispVer-1;

	if ((dispPosY+dispVer) > 511)
		myHeight = 511-dispPosY;
	_asm 
	{
		push	edi
		push	esi

        mov     ecx,[myHeight]
        mov     ebx,dst
        mov     edx,[psxVuw]
        mov		eax,[dispPosY]
        shl     eax,11
        add     edx,eax
        mov		eax,[dispPosX]
        shl     eax,1
        add     edx,eax
        movq    mm0,[maskR]
        movq    mm1,[maskB]
        movq    mm2,[maskG]
        mov     edi,width
        shr     edi,3
		mov		[myWidth],edi
		mov		edi,pitch
		add		edi,width
		add		edi,width
_aline:
        mov     eax,[myWidth]
        mov     esi,0
_sline:
        movq    mm3,[edx+esi]
        movq    mm6,[edx+esi+8]
        movq    mm4,mm3
        movq    mm5,mm6
        pand    mm4,mm0
        movq    mm7,mm3
        pand    mm5,mm0
        pand    mm3,mm2
        psrlw   mm4,10
        pand    mm7,mm1
        por     mm3,mm4
        psrlw   mm5,10
        movq    mm4,mm6
        psllw   mm7,10
        pand    mm4,mm2
        pand    mm6,mm1
        por     mm3,mm7
        psllw   mm6,10
        por     mm4,mm5
        movq    [ebx],mm3
		movq	[ebx+edi],mm3
        por     mm6,mm4
        add     esi,16
        movq    [ebx+8],mm6
		movq	[ebx+edi+8],mm6
        add     ebx,16
        dec     eax
        jnz     _sline
		add		ebx,pitch
        add     edx,2048
        add		ebx,edi
        loop    _aline
        emms
		pop		esi
		pop		edi
	}
}