#include "StdAfx.h"
#include "syslog.h"

#include "gpu_i.h"

// temporary only
#include "draw.h"

//#define syslog //syslog

void cmdSTP(unsigned char * baseAddr)
{
	unsigned long gdata = ((unsigned long*)baseAddr)[0];
	syslog(77," CMD: STP: %x",gdata&0xffffff);
}


void cmdTexturePage(unsigned char * baseAddr)
{
	unsigned long gdata = ((unsigned long*)baseAddr)[0];
	textAddrX = (gdata&0xf)<<6;
	// this one is only for speeding up other calculations
	textAddrX2 = (gdata&0xf)<<7;
	textAddrY = (((gdata)<<4)&0x100)+(((gdata)>>2)&0x200);
	textTP = (gdata & 0x180) >> 7;
	textABR = (gdata >> 5) & 0x3;
	textREST = (gdata&0x00ffffff)>>9;
	syslog(77," CMD: TPage: %d,%d TP=%d ABR=%d REST=%x\n",textAddrX,textAddrY,textTP,textABR,(gdata&0x00ffffff)>>9);
	return;
}

void cmdTextureWindow(unsigned char *baseAddr)
{
	unsigned long gdata = ((unsigned long*)baseAddr)[0];
	syslog(77,"CDM: TWin: %x *NI*", gdata&0xffffff);
}

void cmdDrawAreaStart(unsigned char * baseAddr)
{
	unsigned long gdata = ((unsigned long*)baseAddr)[0];
	drawX = gdata & 0x3ff;
	drawY = (gdata>>10)&0x1ff;
	syslog(77," CMD: DrawArea Start %d,%d %x",drawX,drawY,gdata);
}

void cmdDrawAreaEnd(unsigned char * baseAddr)
{
	unsigned long gdata = ((unsigned long*)baseAddr)[0];
	drawW = gdata & 0x3ff;
	drawH = (gdata>>10)&0x1ff;
	syslog(77," CMD: DrawArea End %d,%d",drawW,drawH);
}

void cmdDrawOffset(unsigned char * baseAddr)
{
	unsigned long gdata = ((unsigned long*)baseAddr)[0];
	ofsX = gdata & 0x3ff;
	ofsY = (gdata>>11)&0x1ff;
	syslog(77," CMD: Draw Offset %d,%d",ofsX,ofsY,gdata);
}

void primLoadImage(unsigned char * baseAddr)
{
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	imageX0 = (gpuData[1] & 0xffff);
	imageY0 = (gpuData[1]>>16) & 0xffff;
	imageX1 = (gpuData[2] & 0xffff);
	imageY1 = ((gpuData[2]>>16) & 0xffff);

	syslog(1," CMD: MEM->VRAM %d,%d %d,%d\n",imageX0,imageY0,imageX1,imageY1);
	imTX=imageX0; imTY=imageY0;
	imTXc=imageX1; imTYc=imageY1;
	imageTransfer = 1;
}

void primStoreImage(unsigned char * baseAddr)
{
	unsigned long *gpuData = ((unsigned long *) baseAddr);

	imageX0 = (gpuData[1] & 0x3ff);
	imageY0 = (gpuData[1]>>16) & 0x1ff;
	imageX1 = (gpuData[2] & 0xffff);
	imageY1 = ((gpuData[2]>>16) & 0xffff);

	syslog(1," CMD: VRAM->MEM %d,%d %d,%d\n",imageX0,imageY0,imageX1,imageY1);
	imTX=imageX0; imTY=imageY0;
	imTXc=imageX1; imTYc=imageY1;
	imSize=imageY1*imageX1/2;

	imageTransfer = 2;
	GPUstatusRet|=0x08000000;
}

void primMoveImage(unsigned char * baseAddr)
{
    // 0x80 image move (VRAM->VRAM)
	unsigned long *gpuData = ((unsigned long *) baseAddr);

	unsigned short imageY0,imageX0,imageY1,imageX1,imageSX,imageSY,i,j;

    imageX0 = (gpuData[1] & 0x3ff);
    imageY0 = (gpuData[1]>>16) & 0x1ff;

    imageX1 = (gpuData[2] & 0x3ff);
    imageY1 = ((gpuData[2]>>16) & 0x1ff);

    imageSY = ((gpuData[3]>>16) & 0xffff);
    imageSX = (gpuData[3] & 0xffff);
	syslog(1," CMD: VRAM->VRAM %d,%d -> %d,%d (%d,%d)\n",imageX0,imageY0,imageX1,imageY1,imageSX,imageSY);
    
    if((imageY0+imageSY)>512) imageSY=512-imageY0;
    if((imageY1+imageSY)>512) imageSY=512-imageY1;
    if((imageX0+imageSX)>1024) imageSX=1024-imageX0;
    if((imageX1+imageSX)>1024) imageSX=1024-imageX1;
    for(j=0;j<imageSY;j++)
		for(i=0;i<imageSX;i++)
			psxVuw[1024*(imageY1+j)+imageX1+i]=psxVuw[1024*(imageY0+j)+imageX0+i];
}





void primBlkFill(unsigned char * baseAddr)
{
	unsigned short * baseAddrW = (unsigned short*) baseAddr;
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	long x0,x1,y0,y1;
	unsigned short newColor1;
	long i,j;
	syslog(2,"BlkFill : %04x,%04x - %04x,%04x",baseAddrW[2],baseAddrW[3],baseAddrW[4],baseAddrW[5]);
	if (drawLace) syslog(2,"DRAW LACE");
	syslog(2,"DISP: %s DRAWING: %s",dispLace?"LACE":" ",drawingLines?"LACE":" ");

//	if (baseAddrW

	unsigned long my1;

	
	y0 = (gpuData[1]>>16) & 0xffff;
	x0 = (gpuData[1] & 0xffff);
	y1 = ((gpuData[2]>>16) & 0xffff) + y0;
	x1 = (gpuData[2] & 0xffff) + x0;
		
	newColor1 = ((gpuData[0]>>9)&0x7c00) | ((gpuData[0]>>6)&0x3e0) | ((gpuData[0]>>3) & 0x1f);

	if((y0<=y1) && (x0<=x1))
	{
		if(y0>511) return;
		if(x0>1023) return;
		if(y1>511) y1 = 511;
		if(x1>1023) x1=1023;

		if(drawLace)
		{
			y0+=drawingLines;
			y1-=drawingLines;
			for(i=y0;i<y1;i+=2)
				for(j=x0;j<x1;j++)
					psxVuw[i*1024+j]=newColor1;
		}
		else
		{
			for(i=y0;i<y1;i++)
					for(j=x0;j<x1;j++)
						psxVuw[i*1024+j]=newColor1;
		}
	}
	return;


  
	
	if (dispLace==0)
	{
	__asm
	{
		mov	edx,baseAddr
		movzx	ecx,byte ptr[edx+0]	// R
		shr		ecx,3
		movzx	eax,byte ptr[edx+1]
		shl		eax,2				// G
		and		eax,03e0h
		or		ecx,eax
		movzx	eax,byte ptr[edx+2]
		shl		eax,7
		and		eax,07c00h
		or		ecx,eax
		mov		[my1],ecx

		mov		ebx,[psxVuw]
		movzx	eax,word ptr[edx+6]	// Y Pos
		and		eax,01ffh
		shl		eax,11				// *2048
		add		ebx,eax

		movzx	ecx,word ptr[edx+8]
		test	ecx,ecx
		jz		_end

		movzx	ecx,word ptr[edx+4]
		cmp		ecx,03ffh
		jnc		_end

		movzx	ecx,word ptr[edx+10] // Height
		mov		edi,ecx
		test	ecx,ecx
		jz		_end
		add		eax,ecx
		cmp		eax,01feh
		jnc		_pre
		mov		edi,01feh
		sub		edi,eax
_pre:

		mov		eax,[my1]
_column:
		movzx ecx,word ptr[edx+8]
		xor esi,esi
		mov si,[edx+4]
		shl esi,1
_line:
		mov [ebx+esi],ax
		add esi,2
		loop _line
		add		ebx,2048
		dec		edi
		jnz		_column
_end:
	}
	}
	else
	{
	if(drawingLines&1)
	__asm
	{
		mov	edx,baseAddr
		movzx	ecx,byte ptr[edx+0]	// R
		shr		ecx,3
		movzx	eax,byte ptr[edx+1]
		shl		eax,2				// G
		and		eax,03e0h
		or		ecx,eax
		movzx	eax,byte ptr[edx+2]
		shl		eax,7
		and		eax,07c00h
		or		ecx,eax
		mov		[my1],ecx

		mov		ebx,[psxVuw]
		movzx	eax,word ptr[edx+6]	// Y Pos
		and		eax,01ffh
		shl		eax,11				// *2048
		add		ebx,eax

		movzx ecx,word ptr[edx+8]
		test	ecx,ecx
		jz		_endL0

		movzx	ecx,word ptr[edx+4]
		cmp		ecx,03ffh
		jnc		_endL0

		movzx	eax,word ptr[edx+6]
		movzx	ecx,word ptr[edx+10] // Height
		sub		ecx,4
		test	ecx,ecx
		jz		_endL0
		mov		edi,ecx
		add		ecx,eax
		cmp		ecx,01feh
		jnc		_preL0
		mov		edi,01feh
		sub		edi,eax
_preL0:
		mov		eax,[my1]
		shr		edi,1
		test	edi,edi
		jz		_endL0
_columnL0:
		movzx	ecx,word ptr[edx+8]
		movzx	esi,word ptr[edx+4]
		shl		esi,1
_lineL0:
		mov		[ebx+esi],ax
		add		esi,2
		loop	_lineL0
		add		ebx,4096
		dec		edi
		jnz		_columnL0
_endL0:
	}
	else
	{
	return;
	__asm
	{
		mov	edx,baseAddr
		movzx	ecx,byte ptr[edx+0]	// R
		shr		ecx,3
		movzx	eax,byte ptr[edx+1]
		shl		eax,2				// G
		and		eax,03e0h
		or		ecx,eax
		movzx	eax,byte ptr[edx+2]
		shl		eax,7
		and		eax,07c00h
		or		ecx,eax
		mov		[my1],ecx

		mov		ebx,[psxVuw]
		movzx	eax,word ptr[edx+6]	// Y Pos
		add		eax,1
		and		eax,01ffh
		shl		eax,11				// *2048
		add		ebx,eax

		movzx ecx,word ptr[edx+8]
		test	ecx,ecx
		jz		_endL1

		movzx	ecx,word ptr[edx+4]
		cmp		ecx,03ffh
		jnc		_endL1

		movzx	eax,word ptr[edx+6]
		movzx	ecx,word ptr[edx+10] // Height
		sub		ecx,1
		test	ecx,ecx
		jz		_endL1
		mov		edi,ecx
		add		ecx,eax
		cmp		ecx,01feh
		jnc		_preL1
		mov		edi,01feh
		sub		edi,eax
_preL1:
		mov		eax,[my1]
		shr		edi,1
		test	edi,edi
		jz		_endL1
_columnL1:
		movzx ecx,word ptr[edx+8]
		xor esi,esi
		mov si,[edx+4]
		shl esi,1
_lineL1:
		mov [ebx+esi],ax
		add esi,2
		loop _lineL1
		add	ebx,4096
		dec	edi
		jnz _columnL1
_endL1:
	}
	}
	
	
	}
	return;
}

void primTileS(unsigned char * baseAddr)
{
	unsigned short * baseAddrW = (unsigned short*) baseAddr;
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	long x0,x1,y0,y1;
	syslog(2,"Tile S *NI* %04x,%04x - %04x,%04x",baseAddrW[2],baseAddrW[3],baseAddrW[4],baseAddrW[5]);
	primBlkFill(baseAddr);
		
	return;
}

void primSprt8(unsigned char * baseAddr)
{
	unsigned long clutAddr;
	unsigned long spriteW;
	unsigned long spriteH;
	unsigned long textA;
	unsigned long textX;
	long sprtY,sprtX,sprtW,sprtH;
	long clutY0,clutX0,clutP,textX0,textY0,sprtYa,sprCY,sprCX;
	short color,tC;
		unsigned long *gpuData = (unsigned long *)baseAddr;

	unsigned short * baseAddrW = (unsigned short *)baseAddr;
	clutAddr = ((baseAddrW[5]<<4)&0x03f0)*2 + ((baseAddrW[5]>>6)&0x1ff)*2048;
    sprtY = (gpuData[1]>>16) & 0xffff;
    sprtX = (gpuData[1] & 0xffff);
    clutY0 = (gpuData[2]>>22) & 0x1ff;
    clutX0 = (gpuData[2]>>12) & 0x3f0;
    clutP  = (clutY0*2048) + (clutX0*2);
    textY0 = ((gpuData[2]>>8) & 0x000000ff) + textAddrY;
    textX0 = (gpuData[2] & 0x000000ff);

    sprtW=8;
    sprtH=8;

    sprtX+=ofsX;
    sprtY+=ofsY;

    if(sprtY<drawY)
     {
      if((sprtY+sprtH)<drawY) return;
      sprtH-=(drawY-sprtY);
      textY0+=(drawY-sprtY);
      sprtY=drawY;
     }
    if(sprtX<drawX)
     {
      if((sprtX+sprtW)<drawX) return;
      sprtW-=(drawX-sprtX);
      textX0+=(drawX-sprtX);
      sprtX=drawX;
     }

    if(((sprtY)>drawH) || ((sprtX)>drawW)) return;
    if ((sprtY+sprtH) >= drawH) sprtH=drawH-sprtY-1;
    if ((sprtX+sprtW) >= drawW) sprtW=drawW-sprtX-1;
    switch (textTP)
     {
      case 0:
       sprtW=sprtW/2;
       textX0=textAddrX*2+textX0/2;
       sprtX=sprtX;
       sprtYa=sprtY*1024;
       clutP=clutY0*1024+clutX0;
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          tC = ((psxVub[(textY0+sprCY)*2048 + textX0 + sprCX]) & 0x0f);
          if(psxVuw[clutP+tC])
           psxVuw[sprtYa+sprCY*1024+sprtX + sprCX*2] = psxVuw[clutP+tC];
          tC = ((psxVub[(textY0+sprCY)*2048 + textX0 + sprCX]>>4)& 0xf);
          if(psxVuw[clutP+tC])
           psxVuw[sprtYa+sprCY*1024+sprtX + sprCX*2+1] = psxVuw[clutP+tC];
         }
//       if(updateThen) updateDisplay();
       return;

      case 1:
       clutP>>=1;
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          tC = psxVub[(textY0+sprCY)*2048+textAddrX*2 + textX0 + sprCX] & 0xff;
          if(color=psxVuw[clutP+tC])
           psxVuw[(sprtY+sprCY)*1024+sprtX + sprCX] = color;
         }
       return;
      case 2:
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          color = psxVuw[(textY0+sprCY)*1024+textAddrX + textX0 + sprCX];
          if(color!=0)
           psxVuw[(sprtY+sprCY)*1024+sprtX + sprCX] = color;
 /*         psxVub[(sprtY+sprCY)*2048+sprtX + sprCX*2] = psxVub[(textY0+sprCY)*2048+textAddrX*2 + textX0 + sprCX*2];
          psxVub[(sprtY+sprCY)*2048+sprtX + sprCX*2+1] = psxVub[(textY0+sprCY)*2048+textAddrX*2 + textX0 + sprCX*2+1];*/
         }
	}
	return;

	switch (textTP)
	{
	case 2:
		syslog(99,"Sprt-8 16-bit");
		return;
	case 1:
		syslog(99,"Sprt-8 8-bit");
		return;
	case 0:
		syslog(99,"Sprt-8 4-bit");
		__asm
		{
			mov		edx,baseAddr
		
			movzx	eax, byte ptr [edx+8]		// textX
			mov		[textX],eax

			movzx	esi, byte ptr [edx+9]		// textY
			mov		ecx,8 ;word ptr [edx+14]		// sprtH

			movsx	edi, word ptr [edx+6]		// sprtY
			add		edi,[ofsY]

			mov		eax,edi						// sprtY+ofsY
			cmp		eax,[drawY]
			jge		_0upvisible
			mov		ebx,8
			;movzx	ebx,word ptr[edx+14]		// sprtH
			add		ebx,eax
			mov		eax,[drawY]
			sub		ebx,eax
			jc		SS0_end
			mov		ecx,ebx
			sub		esi,ebx
			mov		ebx,8
			;movzx	ebx,word ptr[edx+14]		// sprtH
			add		esi,ebx
			mov		edi,eax
_0upvisible:
			test	ecx,ecx
			jz		SS0_end
			cmp		eax,[drawH]
			jnbe	SS0_end
			mov		ebx,8
			;movzx	ebx,word ptr[edx+14]				// sprtH
			add		eax,ebx
			sub		eax,[drawH]
			jc		SS_0nocutdown
			sub		ecx,eax
			test	ecx,ecx
			jz		SS0_end
SS_0nocutdown:
			mov		[spriteH],ecx

			shl		edi,11			// * 2048

			mov		ecx,8

			movzx	eax, word ptr [edx+4]		// sprtX
			add		eax,[ofsX]
			cmp		eax,[drawX]
			jnbe	SS0_leftOK
			mov		ebx,8
			add		ebx,eax
			sub		ebx,[drawX]
			jc		SS0_end
			mov		ecx,ebx
			mov		eax,0

SS0_leftOK:
			cmp		eax,[drawW]
			jnbe	SS0_end
			mov		ebx,8
			add		ebx,eax
			cmp		ebx,[drawW]
			jbe		SS_0rightvisible
			sub		ebx,eax
			mov		ecx,ebx
			
SS_0rightvisible:			
			shr		ecx,1
			mov		[spriteW],ecx		

			shl		eax,1
			add		edi,eax

			mov		ebx,[psxVuw]

			add		esi,[textAddrY]
			shl		esi,11
			add		esi,ebx
			add		esi,[textAddrX2]
			mov		[textA],esi

			mov		esi, [textX]		// textX
			shr		esi,1

			mov		ecx, [spriteH]

			mov		edx,ebx
			add		edx,[clutAddr]


_column0:
			push	ecx
			push	esi
			push	edi
			mov		ecx,[spriteW]
_line0:
			push	ecx
			mov		ecx,[textA]
			movzx	eax, byte ptr [ecx+esi]
			push	eax
			and		al,0fh
			mov		ax,[edx+eax*2]
			test	ax,ax
			jz		_0nodraw1
			mov		[ebx+edi],ax
_0nodraw1:
			pop		eax
			shr		eax,4
			mov		ax,[edx+eax*2]
			test	ax,ax
			jz		_0nodraw2
			mov		[ebx+edi+2],ax
_0nodraw2:
			add		esi,1
			and		esi,0ffh
			add		edi,4
			pop		ecx
			loop	_line0
			pop		edi
			pop		esi
			add		[textA],2048
			add		edi,2048
			pop		ecx
			loop	_column0
SS0_end:
		}
/*		__asm
		{
			mov	edx,baseAddrW
			mov eax,addr
			shl eax,1
			add edx,eax
		

			movzx	esi, byte ptr [edx+9]		// textY

			mov		ecx,8						// sprtH

			movsx	edi, word ptr [edx+6]		// sprtY
			add		edi,[ofsY]

			mov		eax,edi						// sprtY+ofsY
			cmp		eax,[drawY]
			jge		S8_0upvisible	// jump if sprtY > drawY 
			mov		ebx,8			// sprtH
			add		ebx,eax			// end of sprite
			mov		eax,[drawY]	
			sub		ebx,eax			// ebx = lines of sprite that are visible
			jc		S80_end		// the sprite is fully outside draw area
			add		esi,8
			sub		esi,ebx
			mov		ecx,ebx
			mov		edi,eax
S8_0upvisible:
			cmp		eax,[drawH]
			jnbe	S80_end
			mov		ebx,8						// sprtH
			add		eax,ebx
			sub		eax,[drawH]
			jc		S8_0nocutdown
			sub		ecx,eax
			test	ecx,ecx
			jz		S80_end

S8_0nocutdown:
			mov		[spriteH],ecx
			shl		edi,11			// * 2048

			mov	ecx, 8			// sprtW
			shr		ecx,1
			mov		[spriteW],ecx		

			movzx	eax, word ptr [edx+4]		// sprtX
			add		eax,[ofsX]
			cmp		eax,[drawX]
			jc		S80_end
			cmp		eax,[drawW]
			jnbe	S80_end
			mov		ebx,8				// sprtW
			add		ebx,eax
			cmp		ebx,[drawW]
			jbe		S8_0rightvisible
			sub		ebx,eax
			mov		[spriteW],ebx
			
S8_0rightvisible:			
			shl		eax,1
			add		edi,eax

			mov		ebx,[psxVuw]

			add		esi,[textAddrY]
			shl		esi,11
			add		esi,ebx
			add		esi,[textAddrX2]
			mov		[textA],esi

			movzx	esi, byte ptr [edx+8]		// textX
			shr		esi,1

			movzx	ecx, [spriteH]

			mov		edx,ebx
			add		edx,[clutAddr]

S8_column0:
			push	ecx
			push	esi
			push	edi
			mov		ecx,[spriteW]
S8_line0:
			push	ecx
			mov		ecx,[textA]
			movzx	eax, byte ptr [ecx+esi]
			push	eax
			and		al,0fh
			mov		ax,[edx+eax*2]
			test	ax,ax
			jz		S8_0nodraw1
			mov		[ebx+edi],ax
S8_0nodraw1:
			pop		eax
			shr		eax,4
			mov		ax,[edx+eax*2]
			test	ax,ax
			jz		S8_0nodraw2
			mov		[ebx+edi+2],ax
S8_0nodraw2:
			add		esi,1
			and		esi,0ffh
			add		edi,4
			pop		ecx
			loop	S8_line0
			pop		edi
			pop		esi
			add		[textA],2048
			add		edi,2048
			pop		ecx
			loop	S8_column0
S80_end:
		}
*/		return;
	//__asm{

	}
}

void primSprt16(unsigned char * baseAddr)
{
	//return;
	//unsigned char * baseAddrB;
	//baseAddrB = (unsigned char *)baseAddrW+(addr*2);
	//syslog(1,"SPRT-S %x,%x %x,%x %x %x", baseAddrW[addr+2],baseAddrW[addr+3],baseAddrW[addr+4],baseAddrW[addr+5],baseAddrW[addr+6],baseAddrW[addr+7]);
	//syslog(2,"%d %d",baseAddrB[8],baseAddrB[9]);
	unsigned long clutAddr;
	unsigned long spriteW;
	unsigned long spriteH;
	unsigned long textA;
	unsigned long textX;
	long sprtY,sprtX,sprtW,sprtH;
	long clutY0,clutX0,clutP,textX0,textY0,sprtYa,sprCY,sprCX;
	short color,tC;
		unsigned long *gpuData = (unsigned long *)baseAddr;

		sprtY = (gpuData[1]>>16) & 0xffff;
		sprtX = (gpuData[1] & 0xffff);
		clutY0 = (gpuData[2]>>22) & 0x1ff;
		clutX0 = (gpuData[2]>>12) & 0x3f0;
		clutP  = (clutY0*2048) + (clutX0*2);
		textY0 = ((gpuData[2]>>8) & 0x000000ff) + textAddrY;
		textX0 = (gpuData[2] & 0x000000ff);

		sprtW=16;
		sprtH=16;  

		sprtX+=ofsX;
		sprtY+=ofsY;

		//fprintf(outfile,"!GPU! SPRT 16: %d,%d T:%d,%d\n",sprtX,sprtY,textX0,(gpuData[2]>>8)&0xff);
    
		if(sprtY<drawY)
		{	
			if((sprtY+sprtH)<drawY) return;
			sprtH-=(drawY-sprtY);
			textY0+=(drawY-sprtY);
			sprtY=drawY;
		}
		if(sprtX<drawX)
		{                      
			if((sprtX+sprtW)<drawX) return;
			sprtW-=(drawX-sprtX);
			textX0+=(drawX-sprtX);
			sprtX=drawX;
		}

		if(((sprtY)>drawH) || ((sprtX)>drawW)) return;
		if ((sprtY+sprtH) >= drawH) sprtH=drawH-sprtY-1;
		if ((sprtX+sprtW) >= drawW) sprtW=drawW-sprtX-1;

		switch (textTP)
		{
			case 0:
				sprtW=sprtW/2;
				textX0=textAddrX*2+textX0/2;
				sprtX=sprtX;
				sprtYa=sprtY*1024;
				clutP=clutY0*1024+clutX0;
				for (sprCY=0;sprCY<sprtH;sprCY++)
					for (sprCX=0;sprCX<sprtW;sprCX++)
					{ 
						tC = ((psxVub[(textY0+sprCY)*2048 + textX0 + sprCX]) & 0x0f);
						if(psxVuw[clutP+tC])
           psxVuw[sprtYa+sprCY*1024+sprtX + sprCX*2] = psxVuw[clutP+tC];
          tC = ((psxVub[(textY0+sprCY)*2048 + textX0 + sprCX]>>4)& 0xf);
          if(psxVuw[clutP+tC])
           psxVuw[sprtYa+sprCY*1024+sprtX + sprCX*2+1] = psxVuw[clutP+tC];
         }
       return;

      case 1:
       clutP>>=1;
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          tC = psxVub[(textY0+sprCY)*2048+textAddrX*2 + textX0 + sprCX] & 0xff;
          if(color=psxVuw[clutP+tC])
           psxVuw[(sprtY+sprCY)*1024+sprtX + sprCX] = color;
         }
       return;
      case 2:
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          color = psxVuw[(textY0+sprCY)*1024+textAddrX + textX0 + sprCX];
          if(color!=0)
           psxVuw[(sprtY+sprCY)*1024+sprtX + sprCX] = color;
         }
       return;
      default:
		syslog(99,"!GPU! SPRT 16 not performed\n");
		return;
     }

}
void primSprtS(unsigned char * baseAddr)
{
	//return;
	//unsigned char * baseAddrB;
	//baseAddrB = (unsigned char *)baseAddrW+(addr*2);
	//syslog(1,"SPRT-S %x,%x %x,%x %x %x", baseAddrW[addr+2],baseAddrW[addr+3],baseAddrW[addr+4],baseAddrW[addr+5],baseAddrW[addr+6],baseAddrW[addr+7]);
	//syslog(2,"%d %d",baseAddrB[8],baseAddrB[9]);
	unsigned long clutAddr;
	unsigned long spriteW;
	unsigned long spriteH;
	unsigned long textA;
	unsigned long textX;
	long sprtY,sprtX,sprtW,sprtH;
	long clutY0,clutX0,clutP,textX0,textY0,sprtYa,sprCY,sprCX;
	short color,tC;
		unsigned long *gpuData = (unsigned long *)baseAddr;
		sprtY = gpuData[1]>>16;
		sprtX = (short)(gpuData[1] & 0xffff);
		sprtH = (gpuData[3]>>16) & 0x1ff;
		sprtW = (gpuData[3] & 0x3ff);
		clutY0 = (gpuData[2]>>22) & 0x1ff;
		clutX0 = (gpuData[2]>>12) & 0x3f0;
		clutP  = (clutY0*2048) + (clutX0*2);
		textY0 = ((gpuData[2]>>8) & 0x000000ff) + textAddrY;
		textX0 = (gpuData[2] & 0x000000ff);

		syslog(33,"SPRT %d,%d %d,%d Text: %d,%d",sprtX,sprtY,sprtW,sprtH,(gpuData[2])&0xff,(gpuData[2]>>8)&0xff);
		sprtX+=ofsX;
		sprtY+=ofsY;

		while (sprtX>1023)	sprtX-=1024;
		while (sprtY>511)	sprtY-=512;
    
		if(sprtX>drawW)
		{
			if ( (sprtX+sprtW)>1023 ) sprtX-=1024;
			else return;
		}

		if(sprtY>drawH)
		{
			if ( (sprtY+sprtH)>511 ) sprtY-=512;
			else return;
		}

		if(sprtY<drawY)
		{
			if((sprtY+sprtH)<drawY) return;
			sprtH-=(drawY-sprtY);
			textY0+=(drawY-sprtY);
			sprtY=drawY;
		}

		if(sprtX<drawX)
		{
			if((sprtX+sprtW)<drawX) return;
			sprtW-=(drawX-sprtX);
			textX0+=(drawX-sprtX);
			sprtX=drawX;
		}


    if ((sprtY+sprtH) >= drawH) sprtH=drawH-sprtY-1;
    if ((sprtX+sprtW) >= drawW) sprtW=drawW-sprtX-1;

	syslog(0,"SPRT %d", textTP);
    switch (textTP)
     {
      case 0: // texture is 4-bit
       sprtW=sprtW/2;
       textX0=textAddrX*2+textX0/2;
       sprtYa=sprtY*1024;
       clutP=clutY0*1024+clutX0;
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          tC = ((psxVub[(textY0+sprCY)*2048 + textX0 + sprCX]) & 0x0f);
          if(psxVuw[clutP+tC])
           psxVuw[sprtYa+sprCY*1024+sprtX + sprCX*2] = psxVuw[clutP+tC];
          tC = ((psxVub[(textY0+sprCY)*2048 + textX0 + sprCX]>>4)& 0xf);
          if(psxVuw[clutP+tC])
           psxVuw[sprtYa+sprCY*1024+sprtX + sprCX*2+1] = psxVuw[clutP+tC];
         }
//       if(updateThen) updateDisplay();
       return;

      case 1: 
       clutP>>=1;
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          tC = psxVub[(textY0+sprCY)*2048+textAddrX*2 + textX0 + sprCX] & 0xff;
          if(color=psxVuw[clutP+tC])
           psxVuw[(sprtY+sprCY)*1024+sprtX + sprCX] = color;
         }
       return;
      case 2:
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          color = psxVuw[(textY0+sprCY)*1024+textAddrX + textX0 + sprCX];
          if(color!=0)
           psxVuw[(sprtY+sprCY)*1024+sprtX + sprCX] = color;
         }
       return;
     }  
    return;

	__asm
	{
		mov		edx,baseAddr
		movzx	ebx,word ptr[edx+10]
		mov		eax,ebx
		shl		eax,5
		and		eax,07e0h
		and		ebx,07fc0h
		shl		ebx,5
		or		eax,ebx
		mov		[clutAddr],eax
	}
	
	//clutAddr = ((baseAddrW[addr+5]<<5)&0x07e0) + (((baseAddrW[addr+5])&0x7fc0)<<5);
	switch (textTP)
	{
	case 2:
		syslog(99,"SPRT-S 16bit! *NI* ");
		return;
	case 1:
		//syslog(99,"SPRT-S 8 bit!");
	__asm
	{
		mov	edx,baseAddr
		
		mov		ebx,[psxVuw]

		movzx	edi, word ptr [edx+6]		// sprtY
		add		edi,[ofsY]
		shl		edi,11			// * 2048
		movzx	eax, word ptr [edx+4]
		shl		eax,1
		add		edi,eax

		movzx	eax, byte ptr [edx+9]		// textY
		add		eax,[textAddrY]
		shl		eax,11
		add		eax,ebx
		mov		ecx,[textAddrX]
		shl		ecx,1
		add		eax,ecx
		mov		[textA],eax

		movzx	esi, byte ptr [edx+8]		// textX

		movzx	ecx, word ptr [edx+12]
		mov		[spriteW],ecx		

		movzx	ecx, word ptr [edx+14]

		mov		edx,ebx
		add		edx,[clutAddr]

_column1:
		push	ecx
		push	esi
		push	edi
		mov		ecx,[spriteW]
_line1:
		push	ecx
		mov		ecx,[textA]
		movzx	eax, byte ptr [ecx+esi]
		mov		ax,[edx+eax*2]
		mov		[ebx+edi],ax
		add		esi,1
		and		esi,0ffh
		add		edi,2
		pop		ecx
		loop	_line1
		pop		edi
		pop		esi
		add		[textA],2048
		add		edi,2048
		pop		ecx
		loop	_column1
	}
		return;
	case 0:
		syslog(99,"Sprt 4-bit");
		__asm
		{
			mov		edx,baseAddr
		
			movzx	eax, byte ptr [edx+8]		// textX
			mov		[textX],eax

			movzx	esi, byte ptr [edx+9]		// textY
			movzx	ecx,word ptr [edx+14]		// sprtH

			movsx	edi, word ptr [edx+6]		// sprtY
			add		edi,[ofsY]

			mov		eax,edi						// sprtY+ofsY
			cmp		eax,[drawY]
			jge		SS_0upvisible
			movzx	ebx,word ptr[edx+14]		// sprtH
			add		ebx,eax
			mov		eax,[drawY]
			sub		ebx,eax
			jc		SS0_end
			mov		ecx,ebx
			sub		esi,ebx
			movzx	ebx,word ptr[edx+14]		// sprtH
			add		esi,ebx
			mov		edi,eax
SS_0upvisible:
			test	ecx,ecx
			jz		SS0_end
			cmp		eax,[drawH]
			jnbe	SS0_end
			movzx	ebx,word ptr[edx+14]				// sprtH
			add		eax,ebx
			sub		eax,[drawH]
			jc		SS_0nocutdown
			sub		ecx,eax
			test	ecx,ecx
			jz		SS0_end
SS_0nocutdown:
			mov		[spriteH],ecx
			shl		edi,11			// * 2048

			movzx	ecx, word ptr [edx+12]

			movsx	eax, word ptr [edx+4]		// sprtX
			add		eax,[ofsX]
			cmp		eax,[drawX]
			jge		SS0_leftOK
			movzx	ebx,word ptr[edx+12]		// sprtW
			add		ebx,eax
			sub		ebx,[drawX]
			jng		SS0_end
			mov		ecx,ebx
			mov		eax,[drawX]
			movzx	ebx,word ptr[edx+12]		// sprtW
			add		ebx,[textX]
			sub		ebx,ecx
			mov		[textX],ecx
SS0_leftOK:
			cmp		eax,[drawW]
			jnbe	SS0_end
			movzx	ebx,word ptr[edx+12]		// sprtW
			add		ebx,eax
			cmp		ebx,[drawW]
			jc		SS_0rightvisible
			sub		ebx,eax
			mov		ecx,ebx
SS_0rightvisible:
			shr		ecx,1
			test	ecx,ecx
			jz		SS0_end
			mov		[spriteW],ecx

			shl		eax,1
			add		edi,eax

			mov		ebx,[psxVuw]

			add		esi,[textAddrY]
			shl		esi,11
			add		esi,ebx
			add		esi,[textAddrX2]
			mov		[textA],esi

			mov		esi, [textX]		// textX
			shr		esi,1

			mov		ecx, [spriteH]

			mov		edx,ebx
			add		edx,[clutAddr]


_column0:
			push	ecx
			push	esi
			push	edi
			mov		ecx,[spriteW]
_line0:
			push	ecx
			mov		ecx,[textA]
			movzx	eax, byte ptr [ecx+esi]
			push	eax
			and		al,0fh
			mov		ax,[edx+eax*2]
			test	ax,ax
			jz		_0nodraw1
			mov		[ebx+edi],ax
_0nodraw1:
			pop		eax
			shr		eax,4
			mov		ax,[edx+eax*2]
			test	ax,ax
			jz		_0nodraw2
			mov		[ebx+edi+2],ax
_0nodraw2:
			add		esi,1
			and		esi,0ffh
			add		edi,4
			pop		ecx
			loop	_line0
			pop		edi
			pop		esi
			add		[textA],2048
			add		edi,2048
			pop		ecx
			loop	_column0
		}
		return;
	//__asm{
SS0_end:
	//	}
		long temp1,temp2,temp3, temp4;
		__asm
		{
			mov	[temp1],edi
			mov	[temp2],ebx
			mov	[temp3],eax
			mov	[temp4],ecx
		}
//		syslog(99,"SPRT error! sprH: %x edi: %x, ebx, %x, eax: %x, ecx: %x",spriteH, temp1, temp2,temp3,temp4);
		return;
	}
	/*		sprtY = (gpuData[1]>>16) & 0xffff;
		sprtX = (gpuData[1] & 0xffff);
		sprtH = (gpuData[3]>>16) & 0x1ff;
		sprtW = (gpuData[3] & 0x3ff);
		clutY0 = (gpuData[2]>>22) & 0x1ff;
		clutX0 = (gpuData[2]>>12) & 0x3f0;
		clutP  = (clutY0*2048) + (clutX0*2);
		textY0 = ((gpuData[2]>>8) & 0x000000ff) + textAddrY;
		textX0 = (gpuData[2] & 0x000000ff);

		syslog(33,"SPRT %d,%d %d,%d Text: %d,%d",sprtX,sprtY,sprtW,sprtH,(gpuData[2])&0xff,(gpuData[2]>>8)&0xff);
		sprtX+=ofsX;
		sprtY+=ofsY;

		while (sprtX>1023)	sprtX-=1024;
		while (sprtY>511)	sprtY-=512;
    
		if(sprtX>drawW)
		{
			if ( (sprtX+sprtW)>1023 ) sprtX-=1024;
			else return;
		}

		if(sprtY>drawH)
		{
			if ( (sprtY+sprtH)>511 ) sprtY-=512;
			else return;
		}

		if(sprtY<drawY)
		{
			if((sprtY+sprtH)<drawY) return;
			sprtH-=(drawY-sprtY);
			textY0+=(drawY-sprtY);
			sprtY=drawY;
		}

		if(sprtX<drawX)
		{
			if((sprtX+sprtW)<drawX) return;
			sprtW-=(drawX-sprtX);
			textX0+=(drawX-sprtX);
			sprtX=drawX;
		}


    if ((sprtY+sprtH) >= drawH) sprtH=drawH-sprtY-1;
    if ((sprtX+sprtW) >= drawW) sprtW=drawW-sprtX-1;

	syslog(0,"SPRT %d", textTP);
    switch (textTP)
     {
      case 0: // texture is 4-bit
       sprtW=sprtW/2;
       textX0=textAddrX*2+textX0/2;
       sprtYa=sprtY*1024;
       clutP=clutY0*1024+clutX0;
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          tC = ((psxVub[(textY0+sprCY)*2048 + textX0 + sprCX]) & 0x0f);
          if(psxVuw[clutP+tC])
           psxVuw[sprtYa+sprCY*1024+sprtX + sprCX*2] = psxVuw[clutP+tC];
          tC = ((psxVub[(textY0+sprCY)*2048 + textX0 + sprCX]>>4)& 0xf);
          if(psxVuw[clutP+tC])
           psxVuw[sprtYa+sprCY*1024+sprtX + sprCX*2+1] = psxVuw[clutP+tC];
         }
//       if(updateThen) updateDisplay();
       return;

      case 1: 
       clutP>>=1;
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          tC = psxVub[(textY0+sprCY)*2048+textAddrX*2 + textX0 + sprCX] & 0xff;
          if(color=psxVuw[clutP+tC])
           psxVuw[(sprtY+sprCY)*1024+sprtX + sprCX] = color;
         }
       return;
      case 2:
       for (sprCY=0;sprCY<sprtH;sprCY++)
        for (sprCX=0;sprCX<sprtW;sprCX++)
         { 
          color = psxVuw[(textY0+sprCY)*1024+textAddrX + textX0 + sprCX];
          if(color!=0)
           psxVuw[(sprtY+sprCY)*1024+sprtX + sprCX] = color;
         }
       return;
     }  
    return;
*/
}


void primPolyF4(unsigned char *baseAddr)
{
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	short ly0,ly1,ly2,ly3,lx0,lx1,lx2,lx3;

    ly0 = (short) (gpuData[1]>>16) & 0xffff;
    lx0 = (short) (gpuData[1] & 0xffff);
    ly1 = (short) ((gpuData[2]>>16) & 0xffff);
    lx1 = (short) (gpuData[2] & 0xffff);
    ly2 = (short) ((gpuData[3]>>16) & 0xffff);
    lx2 = (short) (gpuData[3] & 0xffff);
    ly3 = (short) ((gpuData[4]>>16) & 0xffff);
    lx3 = (short) (gpuData[4] & 0xffff);
    lx0+=(short) ofsX;
    ly0+=(short) ofsY;
    lx1+=(short) ofsX;
    ly1+=(short) ofsY;
    lx2+=(short) ofsX;
    ly2+=(short) ofsY;
    lx3+=(short) ofsX;
    ly3+=(short) ofsY;
    syslog(77,"!GPU! P4 F %d,%d %d,%d %d,%d %d,%d %6x\n",lx0,ly0,lx1,ly1,lx2,ly2,lx3,ly3,gpuData[0]);
    drawPoly4F(lx0,ly0,lx1,ly1,lx2,ly2,lx3,ly3,gpuData[0]);
    return;
}

void primPolyG4(unsigned char * baseAddr)
{
	short ly0,ly1,ly2,ly3,lx0,lx1,lx2,lx3;

	unsigned long *gpuData = (unsigned long *)baseAddr;
	ly0 = (short) (gpuData[1]>>16) & 0xffff;
	lx0 = (short) (gpuData[1] & 0xffff);
	ly1 = (short) ((gpuData[3]>>16) & 0xffff);
	lx1 = (short) (gpuData[3] & 0xffff);
	ly2 = (short) ((gpuData[5]>>16) & 0xffff);
	lx2 = (short) (gpuData[5] & 0xffff);
	ly3 = (short) ((gpuData[7]>>16) & 0xffff);
	lx3 = (short) (gpuData[7] & 0xffff);
//     fprintf(outfile,"!GPU! P4 G %d,%d %d,%d %d,%d %d,%d\n",lx0,ly0,lx1,ly1,lx2,ly2,lx3,ly3);
    lx0+=ofsX;
    ly0+=ofsY;
    lx1+=ofsX;
    ly1+=ofsY;
    lx2+=ofsX;
    ly2+=ofsY;
    lx3+=ofsX;
    ly3+=ofsY;
    drawPoly4G(lx0,ly0,lx1,ly1,lx2,ly2,lx3,ly3,gpuData[0],gpuData[2],gpuData[4],gpuData[6]);
		return;



}

void primPolyFT3(unsigned char * baseAddr)
{
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	short ly0,ly1,ly2,ly3,lx0,lx1,lx2,lx3;
	unsigned short gpuDataX;
		ly0 = (short) ((gpuData[1]>>16) & 0xffff);
		lx0 = (short) ((gpuData[1] & 0xffff));
		ly1 = (short) ((gpuData[3]>>16) & 0xffff);
		lx1 = (short) (gpuData[3] & 0xffff);
		ly2 = (short) ((gpuData[5]>>16) & 0xffff);
		lx2 = (short) (gpuData[5] & 0xffff);

		// now we gonna add offset to this...
		lx0+=ofsX;
		ly0+=ofsY;
		lx1+=ofsX;
		ly1+=ofsY;
		lx2+=ofsX;
		ly2+=ofsY;

	//     fprintf(outfile,"!GPU! P3 T %d,%d %d,%d %d,%d\n",lx0,ly0,lx1,ly1,lx2,ly2);

		gpuDataX=gpuData[4]>>16;
		textAddrX= (gpuDataX&0xf)<<6;
		textAddrY= (((gpuDataX)<<4)&0x100)+(((gpuDataX)>>2)&0x200);
		textTP= (gpuDataX & 0x180) >> 7;
    switch (textTP)   // depending on texture mode
     {
      case 0:
       fillText4Buffer3V( (gpuData[2] & 0x000000ff), ((gpuData[2]>>8) & 0x000000ff), (gpuData[4] & 0x000000ff), ((gpuData[4]>>8) & 0x000000ff),(gpuData[6] & 0x000000ff), ((gpuData[6]>>8) & 0x000000ff), ((gpuData[2]>>12) & 0x3f0), ((gpuData[2]>>22) & 0x1ff));
       drawPoly3T(lx0,ly0,lx1,ly1,lx2,ly2,newTextX0,newTextY0,newTextX1,newTextY1,newTextX2,newTextY2);
       return;
      case 1:
       fillText8Buffer3V( (gpuData[2] & 0x000000ff), ((gpuData[2]>>8) & 0x000000ff), (gpuData[4] & 0x000000ff), ((gpuData[4]>>8) & 0x000000ff),(gpuData[6] & 0x000000ff), ((gpuData[6]>>8) & 0x000000ff), ((gpuData[2]>>12) & 0x3f0), ((gpuData[2]>>22) & 0x1ff));
       drawPoly3T(lx0,ly0,lx1,ly1,lx2,ly2,newTextX0,newTextY0,newTextX1,newTextY1,newTextX2,newTextY2);
       return;
      case 2:
       drawPoly3TD(lx0,ly0,lx1,ly1,lx2,ly2,(gpuData[2] & 0x000000ff), ((gpuData[2]>>8) & 0x000000ff), (gpuData[4] & 0x000000ff), ((gpuData[4]>>8) & 0x000000ff),(gpuData[6] & 0x000000ff), ((gpuData[6]>>8) & 0x000000ff));
       return;
     }

	
}


void primPolyFT4(unsigned char * baseAddr)
{
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	short ly0,ly1,ly2,ly3,lx0,lx1,lx2,lx3;
	unsigned short gpuDataX;

	//return;

	ly0 = (short)((gpuData[1]>>16) & 0xffff);
	lx0 = (short)((gpuData[1] & 0xffff));
	ly1 = (short)(((gpuData[3]>>16) & 0xffff));
	lx1 = (short)((gpuData[3] & 0xffff));
	ly2 = (short)(((gpuData[5]>>16) & 0xffff));
	lx2 = (short)((gpuData[5] & 0xffff));
	ly3 = (short)(((gpuData[7]>>16) & 0xffff));
	lx3 = (short)((gpuData[7] & 0xffff));
    
    lx0+=(short) ofsX;
    ly0+=(short) ofsY;
    lx1+=(short) ofsX;
    ly1+=(short) ofsY;
    lx2+=(short) ofsX;
    ly2+=(short) ofsY;
    lx3+=(short) ofsX;
    ly3+=(short) ofsY;

		//syslog(22,"!GPU! P4 T %d,%d %d,%d %d,%d %d,%d\n",lx0,ly0,lx1,ly1,lx2,ly2,lx3,ly3);
		//if(ly1>0 && ly2>0 && ly3>0 && ly0>0) return;
		gpuDataX=gpuData[4]>>16;
		textAddrX = (gpuDataX&0xf)<<6;
		textAddrX2 = (gpuDataX&0xf)<<7;
		textAddrY = (((gpuDataX)<<4)&0x100)+(((gpuDataX)>>2)&0x200);
		textTP = (gpuDataX & 0x180) >> 7;
		textABR = (gpuDataX & 0x6) >> 5;
		syslog(22,"!GPU! TPage %d,%d TP=%d ABR=%d REST=%x\n",textAddrX,textAddrY,textTP,textABR,(gpuDataX&0x00ffffff)>>9);
		
		switch (textTP)
		{
		case 0:
			fillText4Buffer4( (gpuData[2] & 0x000000ff), ((gpuData[2]>>8) & 0x000000ff), (gpuData[4] & 0x000000ff), ((gpuData[4]>>8) & 0x000000ff),(gpuData[6] & 0x000000ff), ((gpuData[6]>>8) & 0x000000ff),(gpuData[8] & 0x000000ff), ((gpuData[8]>>8) & 0x000000ff), ((gpuData[2]>>12) & 0x3f0), ((gpuData[2]>>22) & 0x1ff));
			drawPoly4T(lx0,ly0,lx1,ly1,lx3,ly3,lx2,ly2,newTextX0,newTextY0,newTextX1,newTextY1,newTextX3,newTextY3,newTextX2,newTextY2);
			return;
		case 1:
			fillText8Buffer4(
 (gpuData[2] & 0x000000ff), ((gpuData[2]>>8) & 0x000000ff),
 (gpuData[4] & 0x000000ff), ((gpuData[4]>>8) & 0x000000ff),
(gpuData[6] & 0x000000ff), ((gpuData[6]>>8) & 0x000000ff),
(gpuData[8] & 0x000000ff), ((gpuData[8]>>8) & 0x000000ff), 
((gpuData[2]>>12) & 0x3f0), ((gpuData[2]>>22) & 0x1ff));
			drawPoly4T(lx0,ly0,lx1,ly1,lx3,ly3,lx2,ly2,newTextX0,newTextY0,newTextX1,newTextY1,newTextX3,newTextY3,newTextX2,newTextY2);
			return;
		case 2:
			drawPoly4TD(lx0,ly0,lx1,ly1,lx3,ly3,lx2,ly2,

(gpuData[2] & 0x000000ff), ((gpuData[2]>>8) & 0x000000ff),
(gpuData[4] & 0x000000ff), ((gpuData[4]>>8) & 0x000000ff),
(gpuData[8] & 0x000000ff), ((gpuData[8]>>8) & 0x000000ff),
(gpuData[6] & 0x000000ff), ((gpuData[6]>>8) & 0x000000ff));
			return;
		}
		return;

}

void primPolyGT3(unsigned char *baseAddr)
{	
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	short ly0,ly1,lx0,lx1,ly2,lx2;
	ly0 = (gpuData[1]>>16) & 0xffff;
    lx0 = (gpuData[1] & 0xffff);
    ly1 = ((gpuData[4]>>16) & 0xffff);
    lx1 = (gpuData[4] & 0xffff);
    ly2 = ((gpuData[7]>>16) & 0xffff);
    lx2 = (gpuData[7] & 0xffff);
    // fprintf(outfile,"!GPU! P3 GT %d,%d %d,%d %d,%d\n",lx0,ly0,lx1,ly1,lx2,ly2);
    // now we gonna add offset to this...
    lx0+=ofsX;
    ly0+=ofsY;
    lx1+=ofsX;
    ly1+=ofsY;
    lx2+=ofsX;
    ly2+=ofsY;

/*
    gpuDataX= gpuData[5]>>16;
    textAddrX= (gpuDataX&0xf)<<6;
    textAddrY= (((gpuDataX)<<4)&0x100)+(((gpuDataX)>>2)&0x200);
    textTP= (gpuDataX & 0x180) >> 7;
*/
	drawFlatTriangleGoraud(lx0,ly0,lx1,ly1,lx2,ly2,gpuData[0],gpuData[3],gpuData[6]); 
}

void primPolyG3(unsigned char *baseAddr)
{	
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	short ly0,ly1,lx0,lx1,ly2,lx2;

		ly0 = (short) (gpuData[1]>>16) & 0xffff;
		lx0 = (short) (gpuData[1] & 0xffff);
		ly1 = (short) ((gpuData[3]>>16) & 0xffff);
		lx1 = (short) (gpuData[3] & 0xffff);
		ly2 = (short) ((gpuData[5]>>16) & 0xffff);
		lx2 = (short) (gpuData[5] & 0xffff);
		lx0+=ofsX;
		ly0+=ofsY;
		lx1+=ofsX;
		ly1+=ofsY;
		lx2+=ofsX;
		ly2+=ofsY;
  //  syslog(77,"!GPU! P3 G %d,%d %d,%d %d,%d\n",lx0,ly0,lx1,ly1,lx2,ly2);
    drawFlatTriangleGoraud(lx0,ly0,lx1,ly1,lx2,ly2,gpuData[0],gpuData[2],gpuData[4]);    
}

void primPolyGT4(unsigned char *baseAddr)
{	
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	short ly0,ly1,lx0,lx1,ly2,lx2,ly3,lx3;
	ly0 = (gpuData[1]>>16) & 0xffff;
    lx0 = (gpuData[1] & 0xffff);
    ly1 = ((gpuData[4]>>16) & 0xffff);
    lx1 = (gpuData[4] & 0xffff);
    ly2 = ((gpuData[7]>>16) & 0xffff);
    lx2 = (gpuData[7] & 0xffff);
    ly3 = ((gpuData[10]>>16) & 0xffff);
    lx3 = (gpuData[10] & 0xffff);

	//fprintf(outfile,"!GPU! P4 GT %d,%d %d,%d %d,%d %d,%d\n",lx0,ly0,lx1,ly1,lx2,ly2,lx3,ly3);

/*
    gpuDataX=gpuData[5]>>16;
    textAddrX= (gpuDataX&0xf)<<6;
    textAddrY = (((gpuDataX)<<4)&0x100)+(((gpuDataX)>>2)&0x200);
    textTP = (gpuDataX & 0x180) >> 7;
*/    
    lx0+=ofsX;
    ly0+=ofsY;
    lx1+=ofsX;
    ly1+=ofsY;
    lx2+=ofsX;
    ly2+=ofsY;
    lx3+=ofsX;
    ly3+=ofsY;

    drawPoly4G(lx0,ly0,lx1,ly1,lx2,ly2,lx3,ly3,gpuData[0],gpuData[3],gpuData[6],gpuData[9]);
}

void primPolyF3(unsigned char *baseAddr)
{	
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	short ly0,ly1,lx0,lx1,ly2,lx2;
		ly0 = (short) (gpuData[1]>>16) & 0xffff;
		lx0 = (short) (gpuData[1] & 0xffff);
		ly1 = (short) ((gpuData[2]>>16) & 0xffff);
		lx1 = (short) (gpuData[2] & 0xffff);
		ly2 = (short) ((gpuData[3]>>16) & 0xffff);
		lx2 = (short) (gpuData[3] & 0xffff);
		syslog(77,"!GPU! P3 F %d,%d %d,%d %d,%d\n",lx0,ly0,lx1,ly1,lx2,ly2);
		lx0+=ofsX;
		ly0+=ofsY;
		lx1+=ofsX;
		ly1+=ofsY;
		lx2+=ofsX;
		ly2+=ofsY;
		drawFlatTriangle(lx0,ly0,lx1,ly1,lx2,ly2,gpuData[0]);
}


void primLineF2(unsigned char *baseAddr)
{
	unsigned long *gpuData = ((unsigned long *) baseAddr);
	short ly0,ly1,lx0,lx1;
	syslog(77,"PRIM: LineF2");
	ly0 = (short)((gpuData[1]>>16) & 0xffff);
	lx0 = (short)((gpuData[1] & 0xffff));
	ly1 = (short)(((gpuData[2]>>16) & 0xffff));
	lx1 = (short)((gpuData[2] & 0xffff));
    lx0+=(short) ofsX;
    ly0+=(short) ofsY;
    lx1+=(short) ofsX;
    ly1+=(short) ofsY;
	drawLine(lx0,ly0,lx1,ly1);
}


void primNI(unsigned char *bA)
{
	if (bA[3]) syslog(255,"PRIM: *NI* %02x",bA[3]);
}


unsigned char primTableC[256] =
{
	// 00
	0,0,3,0,0,0,0,0,
	// 08
	0,0,0,0,0,0,0,0,
	// 10
	0,0,0,0,0,0,0,0,
	// 18
	0,0,0,0,0,0,0,0,
	// 20
	4,4,4,4,7,7,7,7,
	// 28
	5,5,5,5,9,9,9,9,
	// 30
	6,6,6,6,9,9,9,9,
	// 38
	8,8,8,8,12,12,12,12,
	// 40
	3,3,3,3,0,0,0,0,
	// 48
	5,5,5,5,6,6,6,6,
	// 50
	4,4,4,4,0,0,0,0,
	// 58
	7,7,7,7,9,9,9,9,	//	LINEG3	LINEG4
	// 60
	3,3,3,3,4,4,4,4,	//	TILE	SPRT
	// 68
	2,2,2,2,0,0,0,0,	//	TILE1
	// 70
	2,2,2,2,3,3,3,3,
	// 78
	2,2,2,2,3,3,3,3,
	// 80
	4,0,0,0,0,0,0,0,
	// 88
	0,0,0,0,0,0,0,0,
	// 90
	0,0,0,0,0,0,0,0,
	// 98
	0,0,0,0,0,0,0,0,
	// a0
	3,0,0,0,0,0,0,0,
	// a8
	0,0,0,0,0,0,0,0,
	// b0
	0,0,0,0,0,0,0,0,
	// b8
	0,0,0,0,0,0,0,0,
	// c0
	3,0,0,0,0,0,0,0,
	// c8
	0,0,0,0,0,0,0,0,
	// d0
	0,0,0,0,0,0,0,0,
	// d8
	0,0,0,0,0,0,0,0,
	// e0
	0,1,1,1,1,1,1,0,
	// e8
	0,0,0,0,0,0,0,0,
	// f0
	0,0,0,0,0,0,0,0,
	// f8
	0,0,0,0,0,0,0,0

};

void (*primTableJ[256])(unsigned char *) = 
{
	// 00
	primNI,primNI,primBlkFill,primNI,primNI,primNI,primNI,primNI,
	// 08
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 10
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 18
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 20
	primPolyF3,primPolyF3,primPolyF3,primPolyF3,primPolyFT3,primPolyFT3,primPolyFT3,primPolyFT3,
	// 28
	primPolyF4,primPolyF4,primPolyF4,primPolyF4,primPolyFT4,primPolyFT4,primPolyFT4,primPolyFT4,
	// 30
	primPolyG3,primPolyG3,primPolyG3,primPolyG3,primPolyGT3,primPolyGT3,primPolyGT3,primPolyGT3,
	// 38
	primPolyG4,primPolyG4,primPolyG4,primPolyG4,primPolyGT4,primPolyGT4,primPolyGT4,primPolyGT4,
	// 40
	primLineF2,primLineF2,primLineF2,primLineF2,primNI,primNI,primNI,primNI,
	// 48
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 50
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 58
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 60
	primTileS,primNI,primNI,primNI,primSprtS,primSprtS,primSprtS,primSprtS,
	// 68
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 70
	primNI,primNI,primNI,primNI,primSprt8,primSprt8,primSprt8,primSprt8,
	// 78
	primNI,primNI,primNI,primNI,primSprt16,primSprt16,primSprt16,primSprt16,
	// 80
	primMoveImage,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 88
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 90
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// 98
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// a0
	primLoadImage,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// a8
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// b0
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// b8
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// c0
	primStoreImage,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// c8
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// d0
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// d8
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// e0
	primNI,cmdTexturePage,cmdTextureWindow,cmdDrawAreaStart,cmdDrawAreaEnd,cmdDrawOffset,cmdSTP,primNI,
	// e8
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// f0
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI,
	// f8
	primNI,primNI,primNI,primNI,primNI,primNI,primNI,primNI
};

